#include <iostream>
#include "MersenneTwister.h"
#include <vector>
#include <math.h>
#include <fstream>
#include <algorithm>

using namespace std;

extern double expdev(double);
double mean(vector<double > t){double sum=0; for (int i=0;i<t.size();i++) sum+=t[i]; return sum/(double) t.size();}
double moment2(vector<double > t){double sum=0; for (int i=0;i<t.size();i++) sum+=t[i]*t[i]; return sum/(double) t.size();}
double variance(vector<double > t){return moment2(t)-mean(t)*mean(t);}
MTRand rnd;

int main()
{
  MTRand al; // random number generator
  ofstream fout; // file for outstream
  vector<double > B(3,0), D(3,0), Bt, Dt;// Birth and death rates for each clone
  vector<vector<double > > C, Ct,S;// competitive interactions between each pair of clone, S = invasion fitness
  vector <long > N(3,0); //number of individuals for each clone
  vector<double > Rates(6); // cumulative sum of rates from which next event is randomly drawn
  long K, rep=200; // scale parameter, number of replicates
  double epsilon=0.01, epsilon1 =0.1, epsilon2 = 0.2, epsilon3 = 0.5, epsilon4 = 0.9, epsilon5=0.99; // threshold values
     double t; //current time
     vector <double > T0, T1, T2, T3,T4, T5, Tfix;// collection of time : T1: first time we reach epsilon K ; T2 : first time we reach S K ; T3 : time almost fixed.
     bool b1=0,b2=0,b3=0,b4=0,b5=0;
     char ch;
     int nbclones; // how many clones in the population?
     double alpha=7;// time at which second clone enters the population
     int exp_max=6; // varying scale parameters 
     

     /******************/
     /* initialization */
     /******************/
     
     C.resize(3); for (int i=0;i<=2;i++) C[i].resize(3);
     Ct=C; Bt=B;Dt=D;
     S=C;   

     //     C[i][j] competition of j on i
     
     //Ct[0][0]=1.8; Ct[0][1]=4.0; Ct[0][2]=3.0;
     //Ct[1][0]=1.0; Ct[1][1]=2.3; Ct[1][2]=3.0; 
     //Ct[2][0]=1.5; Ct[2][1]=1.0; Ct[2][2]=2.1;

     Ct[0][0]=1.0; Ct[0][1]=2.0; Ct[0][2]=1.0;
     Ct[1][0]=1.0; Ct[1][1]=1.0; Ct[1][2]=1.0; 
     Ct[2][0]=1.0; Ct[2][1]=1.0; Ct[2][2]=1.0;

     // B[i] and D[i] individual birth and death rates of i-individuals
     //Bt[0]=2;Bt[1]=2;Bt[2]=2;
     //Dt[0]=0;Dt[1]=0;Dt[2]=0;

     Bt[0]=1;Bt[1]=1.1;Bt[2]=1.11;
     Dt[0]=0;Dt[1]=0;Dt[2]=0;



     
      // S[i][j] invasion fitness of a type i individual into a resident j population
	 S[1][0] = B[1]-D[1]-C[1][0] *(B[0]-D[0])/C[0][0];
	 S[0][1] = B[0]-D[0]-C[0][1] *(B[1]-D[1])/C[1][1];
	 S[2][0] = B[2]-D[2]-C[2][0] *(B[0]-D[0])/C[0][0];
	 S[0][2] = B[0]-D[0]-C[0][2] *(B[2]-D[2])/C[2][2];
	 S[2][1] = B[2]-D[2]-C[2][1] *(B[1]-D[1])/C[1][1];
	 S[1][2] = B[1]-D[1]-C[1][2] *(B[2]-D[2])/C[2][2];
 
 nbclones=3;

  //     C[i][j] competition of j on i
     
     C[0][0]=Ct[0][0]; C[0][1]=Ct[0][1]; C[0][2]=Ct[0][2];
     C[1][0]=Ct[1][0]; C[1][1]=Ct[1][1]; C[1][2]=Ct[1][2]; 
     C[2][0]=Ct[2][0]; C[2][1]=Ct[2][1]; C[2][2]=Ct[2][2];

     // B[i] and D[i] individual birth and death rates of i-individuals
     B[0]=Bt[0];B[1]=Bt[1];B[2]=Bt[2];
     D[0]=Dt[0];D[1]=Dt[1];D[2]=Dt[2];



     
      // S[i][j] invasion fitness of a type i individual into a resident j population
	 S[1][0] = B[1]-D[1]-C[1][0] *(B[0]-D[0])/C[0][0];
	 S[0][1] = B[0]-D[0]-C[0][1] *(B[1]-D[1])/C[1][1];
	 S[2][0] = B[2]-D[2]-C[2][0] *(B[0]-D[0])/C[0][0];
	 S[0][2] = B[0]-D[0]-C[0][2] *(B[2]-D[2])/C[2][2];
	 S[2][1] = B[2]-D[2]-C[2][1] *(B[1]-D[1])/C[1][1];
	 S[1][2] = B[1]-D[1]-C[1][2] *(B[2]-D[2])/C[2][2];

	 cout << "S10=" << S[1][0] << '\t' <<"S01=" << S[0][1]<<  '\n' << "S20=" << S[2][0] << '\t' <<"S02=" << S[0][2]<<  '\n'<< "S21=" << S[2][1] << '\t' <<"S12=" << S[1][2]<<  '\n' ;



double n1=(B[1]-D[1])/C[1][1],n2=(B[2]-D[2])/C[2][2];

/***************************/
/* Simulation runs  ********/ 
/***************************/
 
 if(nbclones==3)
{

  // File management
     fout.open("res3clones.txt");
     fout << "b0" << '\t' << "d0" << '\t'<< "b1" << '\t'<< "d1" << '\t'<< "b2" << '\t'<< "d2" << '\t' << "alpha"<< '\n';
     for (int ii=0; ii<=2;ii++) fout << B[ii] << '\t' << D[ii]<<'\t'; fout << alpha; fout << '\n';
     fout << "C00" << '\t' << "C01"<< '\t' << "C02"<< '\t' << "C10"<< '\t' << "C11"<< '\t' << "C12"<< '\t' << "C20"<< '\t' << "C21"<< '\t' << "C22"<< '\t' << "n1" << '\t' << "n2" << '\n';
     for(int ii=0; ii<=2;ii++) for (int jj=0;jj<=2;jj++) fout << C[ii][jj] << '\t'; fout << (B[1]-D[1])/C[1][1] << '\t' << (B[2]-D[2])/C[2][2] << '\n';
fout << "S10"<< '\t' <<"S01" << '\t' << "S20" << '\t' << "S02" <<  '\t'<< "S21" << '\t' <<"S12" <<  '\n' ;
fout <<  S[1][0] << '\t' << S[0][1]<<  '\t' << S[2][0] << '\t' << S[0][2]<<  '\t'<<  S[2][1] << '\t' << S[1][2]<<  '\n' ;
 fout << "K" << '\t' << "T0.1K"<<'\t' << "T0.2K"<<'\t' << "T0.5K"<<'\t' << "T0.9K" <<'\t' << "T0.99K" <<'\t' << "Tfix" << '\t';
 fout << "Tinv1" << '\t' << "Tdet1" << '\t' << "Tinv2" << '\t' << "Tdet2" << '\t' << "Text1" << '\t' << "Tfix2" << '\n';
     fout.close();



     // simulation starts here
     for(int exp=2;exp<=exp_max;exp++)
       {
	 K=pow(10.0,(double) exp); //scale parameter is fixed
	  cout << "K="<< K << '\n';


double Tinv1=log(0.1*K*S[1][0]/B[1])*1/S[1][0]+1/S[1][0]*0.577; // Tinv1
double Tdet1= (1/S[1][0])* log(n1*(1.0-0.1)/0.1);// Tdet1
double Tinv2= (1/S[2][1])*(log(0.1*K*S[2][0]/B[2])+0.577-S[2][0]*(log(0.1*K*S[1][0]/B[1])/S[1][0]+0.577/S[1][0]-alpha*log(K)));//Tinv2
double Tdet2= log(n2*(1.0-0.1)/0.1)/S[2][1];//Tdet2
double Text1= log(0.1*K)/abs(S[1][2]);//Text1
double Tfix2=Tinv1+Tdet1+Tinv2+Tdet2+Text1;
	  
      	 T0.resize(0); T1.resize(0); T2.resize(0); T3.resize(0); T4.resize(0); T5.resize(0); Tfix.resize(0);
     // Repetitions
     for(int it=1; it<=rep;it++)
       {
	 N[1]=0; N[2]=0;
	 N[0]=K* (B[0]-D[0])/C[0][0];
	 t=0;
	 
	 while( N[0]>0 || N[1] >0) // do events until type 1 or 2 is fixed

       {
	 if((N[1]==0 && N[2]==0) && N[0]>0) {N[1]++; t=0; N[0]=K* (B[0]-D[0])/C[0][0]; b1=0,b2=0,b3=0,b4=0,b5=0; N[2]=0;} // if mutant 1 or 2 is extinct before 0 , start again;
 
	 Rates[0]=N[0]*B[0];
	 Rates[1]=Rates[0]+N[0]*(D[0]+ (C[0][0] * N[0]+ C[0][1] * N[1]+C[0][2] *N[2]) / (double) K);
	 Rates[2]=Rates[1]+N[1]*B[1];
	 Rates[3]=Rates[2]+N[1]*(D[1]+(C[1][0] * N[0]+ C[1][1]* N[1]+C[1][2] *N[2]) / (double) K);
	 Rates[4]=Rates[3]+N[2]*B[2];
	 Rates[5]=Rates[4]+N[2]*(D[2]+(C[2][0]* N[0]+ C[2][1] * N[1]+C[2][2] *N[2])/(double) K);

	 t+=expdev(Rates[5]); // calculate current time

	 double r=al.rand(Rates[5]); 
     
	 int e=0;
     
	 while(r>=Rates[e]) e++; // which event occurs
	 
	 switch(e)
	   {
	   case 0:N[0]++; break;
	   case 1:N[0]--;break;
	   case 2:N[1]++;break;
	   case 3:N[1]--;break;
	   case 4:N[2]++;break;
	   case 5:N[2]--;break;
	   }  
	if (N[2]>epsilon1*K && b1==0) {T1.push_back(t); b1=1;} //
	 if (N[2]>epsilon2*K && b2==0) {T2.push_back(t); b2=1;} //
	   if (N[2]>epsilon3*K && b3==0) {T3.push_back(t);b3=1;} //
	     if (N[2]>epsilon4*K && b4==0) {T4.push_back(t);b4=1;} //
	      if (N[2]>epsilon5*K && b5==0) {T5.push_back(t);b5=1;} //

	      if (t>alpha*log(K) && N[2]==0) {N[2]++;}
	      //cout << N[2] << '\t';
     }
	   
     Tfix.push_back(t);
      cout << it << '\n';
      
       }

     // file management 
         fout.open("res3clones.txt", ios::out | ios::app);
     if (fout.is_open())
       {
	 fout << K << '\t' << mean(T1) << '\t'<< mean(T2) << '\t'<< mean(T3) << '\t'<< mean(T4) << '\t'<< mean(T5)<< '\t'<< mean(Tfix) << '\t';
	 fout << Tinv1 << '\t'; // Tinv1
	 fout << Tdet1 << '\t';// Tdet1
	 fout << Tinv2 << '\t';//Tinv2
	 fout << Tdet2 <<'\t';//Tdet2
	 fout << Text1 << '\t';//Text1
	 fout << Tfix2 << '\n';//Tfix2
       }
     fout.close();
       }
    }
 
    return 0;
}
